<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-03-20 14:36:37
 * @LastEditors: 无尘
 * @LastEditTime: 2020-08-17 16:19:42
 -->
<template>
  <div class="my-customer-wrap common-set-wrap">
    <nav-crumb :navpath="navpath"> </nav-crumb>
    <div class="right-content">
      <div class="right-box" style="min-height: calc(100vh - 104px);">
        <div class="apps-content flex" style="min-height: calc(100vh - 104px);">
          <div class="apps-content-right">
            <div class="flex flex-space-between">
              <div class="font-16 color-303133 font-w-600">近七天所有区域平均登录率趋势</div>
              <div role="alert" class="el-alert el-alert-tip el-alert--info flex flex-align-start w-426">
                <i class="el-alert__icon el-icon-info font-12 color-2f54eb"></i>
                <div class="el-alert__content">
                  <span class="el-alert__title color-606266 font-14">数据更新截至于昨日。今日数据需要隔天上午8点后进行查看。</span>
                </div>
              </div>
            </div>
            <div class="chart-body m-t-20">
              <area-chart v-if="charData.length" :charData="charData" id="area-chart"></area-chart>
              <div v-if="!charData.length" class="no-data-char">
                <img src="../../assets/data/line.png" alt="" />
                <p class="font-12 color-c0c4cc m-t-20">- 暂无数据 -</p>
              </div>
            </div>
            <div class="table-search m-t-20">
              <div class="flex flex-space-between">
                <div>
                  <el-date-picker v-model="selectTableDay" :value-format="'yyyy-MM-dd'" type="date" placeholder="选择日期" :clearable="false" :picker-options="pickerOptions" @change="changeTableDate"> </el-date-picker><gic-select-group-mult class="m-l-10" :selectData="groupIds" @checkGroupIds="checkGroupIds"> </gic-select-group-mult><span class="font-14 color-606266 p-l-10">当日筛选区域下门店总计为 {{ total }} 家：</span>
                </div>
                <el-button v-if="$getButtonLimit($buttonCode.exportAreaLoginUser)" :limit-code="$buttonCode.exportAreaLoginUser" type="primary" :loading="loadingBtn" @click="exportExcel">导出</el-button>
              </div>
            </div>
            <div class="m-t-20">
              <el-table class="select-table" ref="multipleTable" :data="tableData" tooltip-effect="dark" :style="{ width: '100%' }" @selection-change="handleSelectionChange">
                <el-table-column prop="" label="门店名称" show-overflow-tooltip>
                  <template slot-scope="scope">
                    {{ scope.row.xName || '--' }}
                  </template>
                </el-table-column>
                <el-table-column prop="" label="门店code" show-overflow-tooltip>
                  <template slot-scope="scope">{{ scope.row.storeCode || '--' }}</template>
                </el-table-column>
                <el-table-column prop="" label="门店区域" show-overflow-tooltip>
                  <template slot-scope="scope">{{ scope.row.storeGroupName || '--' }}</template>
                </el-table-column>
                <el-table-column prop="" label="登录率" show-overflow-tooltip>
                  <template slot-scope="scope">{{ scope.row.loginRate || '0%' }}</template>
                </el-table-column>
                <el-table-column prop="" label="登录人数" show-overflow-tooltip>
                  <template slot-scope="scope">{{ scope.row.loginClerkCnt || '0' }}</template>
                </el-table-column>
                <el-table-column prop="" label="操作" show-overflow-tooltip>
                  <template slot-scope="scope">
                    <el-button @click="toRedirect(scope.row)" type="text">查看人员名单</el-button>
                  </template>
                </el-table-column>
              </el-table>
              <div class="block common-wrap__page text-right m-t-24" v-if="tableData.length != 0">
                <dm-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </dm-pagination>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- <vue-gic-footer></vue-gic-footer> -->
  </div>
</template>
<script>
import navCrumb from '@/components/nav/nav.vue';
import areaChart from '@/components/login-data/area-chart.vue';
import gicSelectGroupMult from '@/components/login-data/gic-select-group-mult.vue';

import { getRequest, postRequest, postExcel } from '@/api/api';
import errMsg from '@/common/js/error';
// import { _debounce } from '@/common/js/public';
import dateFormat from '@/filters/index.js';
// import showMsg from '@/common/js/showmsg';
export default {
  name: 'activeDetail',
  data() {
    return {
      // 面包屑参数
      navpath: [
        {
          name: '好办使用详情',
          path: '/enterpriseUseData?brandId=' + this.$route.query.brandId
        },
        {
          name: '区域登录明细',
          path: ''
        }
      ],
      selectStartDay: '',
      selectEndDay: '',
      selectTableDay: '',
      pickerOptions: {
        disabledDate(time) {
          const one = 8 * 24 * 3600 * 1000;
          const seven = Date.now() - one;
          return time.getTime() >= Date.now() - 8.64e7 || time.getTime() < seven;
        }
      },
      groupIds: [],
      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0,
      tableData: [],
      multipleSelection: [],
      addShow: false,
      loadingBtn: false,
      selectRadio: 0,
      charData: [] //[{ date: '1991', loginRate: 3 }, { date: '1992', loginRate: 4 }, { date: '1993', loginRate: 3 }, { date: '1994', loginRate: 5 }, { date: '1995', loginRate: 4 }, { date: '1996', loginRate: 6 }, { date: '1997', loginRate: 7 }]
    };
  },
  computed: {},
  methods: {
    /**
     * 选择列表日期
     */
    changeTableDate() {
      const that = this;
      that.getTableList();
    },
    /**
     * 选择门店分组
     */
    checkGroupIds: function(nodes) {
      const that = this;
      that.groupIds = nodes;
      that.getTableList();
    },
    /**
     * 查看人员名单
     */
    toRedirect(row) {
      this.$router.push(`/loginDetail?storeId=${row.xValue}&brandId=${this.$route.query.brandId}&selectTableDay=${this.selectTableDay}`);
    },
    /**
     * 显示选择本页/全部
     */
    handleCommand(command) {
      this.selectRadio = command;
    },
    /**
     * 表格选择
     */
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    /**
     * 导出
     */
    exportExcel() {
      const that = this;
      /*  if (!that.multipleSelection.length) {
        showMsg.showmsg('请选择人员', 'warning');
        return false;
      } */
      that.loadingBtn = true;
      that.postExcelData();
    },
    postExcelData() {
      const that = this;
      let para = {
        enterpriseId: that.$route.query.brandId,
        startDate: that.selectTableDay,
        endDate: that.selectTableDay,
        groupIdList: that.groupIds.map(ele => ele.storeGroupId).join(','),
        selectType: that.selectRadio
        //taskIds: that.selectRadio == 1 ? '' : that.multipleSelection.map(ele => ele.taskId).join(',')
      };
      postExcel('/haoban-manage3-web/web/export-area-ranking-list', para)
        .then(res => {
          that.loadingBtn = false;
          if (!res.data) {
            errMsg.errorMsg('暂无数据');
            return false;
          }
          // let resData = res.data;
          const blob = new Blob([res.data], {
            type: 'application/vnd.ms-excel'
          });
          const fileName = `区域登录明细报表.csv`;
          const elink = document.createElement('a');
          elink.download = fileName;
          elink.style.display = 'none';
          elink.href = URL.createObjectURL(blob);
          document.body.appendChild(elink);
          elink.click();
          URL.revokeObjectURL(elink.href); // 释放URL 对象
          document.body.removeChild(elink);
          // errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loadingBtn = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 路由跳转
     *  @param {String} path
     */
    changeRoute(path) {
      this.$router.push(path);
    },

    /**
     * 分页---页码变化
     *  @param {Number} val
     */
    handleSizeChange(val) {
      const that = this;
      that.currentPage = 1;
      that.pageSize = val;
      that.getTableList();
    },

    /**
     * 分页---当前页变化
     *  @param {Number} val
     */
    handleCurrentChange(val) {
      const that = this;
      that.currentPage = val;
      that.getTableList();
    },
    /**
     * 获取访问趋势数据
     */
    getTendData(val) {
      const that = this;
      let para = {
        enterpriseId: that.$route.query.brandId,
        startDate: that.selectStartDay,
        endDate: that.selectEndDay
      };
      getRequest('/haoban-manage3-web/web/area-ranking-date', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            if (resData.result.result) {
              resData.result.result.forEach(ele => {
                ele.date = `${ele.bizDates}（${ele.weeks}）`;
                ele.loginRate = (ele.loginRate * 1000) / 10;
              });
            }
            that.charData = resData.result.result || [];
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 获取列表数据
     */
    getTableList(val) {
      const that = this;
      let para = {
        enterpriseId: that.$route.query.brandId,
        startDate: that.selectTableDay,
        endDate: that.selectTableDay,
        groupIdList: that.groupIds.map(ele => ele.storeGroupId).join(','),
        pageSize: that.pageSize,
        currentPage: that.currentPage
      };
      postRequest('/haoban-manage3-web/web/area-ranking-list', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            if (!!resData.result.result.list && !!resData.result.result.list.length) {
              !!resData.result.result.list.forEach(ele => {
                ele.loginRate = (ele.loginRate * 1000) / 10 + '%';
              });
            }
            that.tableData = resData.result.result.list || [];
            that.total = resData.result.result.total || 0;
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },
  watch: {
    activeBrand: function(newData, oldData) {
      const that = this;
      that.activeBrand = newData;
    },
    activeGroup: function(newData, oldData) {
      const that = this;
      that.activeGroup = newData;
    }
  },
  mounted() {
    const that = this;
    that.selectStartDay = dateFormat.timeStampToYmd(new Date().getTime() - 7 * 24 * 3600 * 1000);
    that.selectEndDay = dateFormat.timeStampToYmd(new Date().getTime() - 24 * 3600 * 1000);
    that.selectTableDay = dateFormat.timeStampToYmd(new Date().getTime() - 24 * 3600 * 1000);
    that.$nextTick(() => {
      that.getTableList();
      that.getTendData();
    });
    document.documentElement.style.backgroundColor = '#f0f2f5';
  },
  destroyed() {
    document.documentElement.style.backgroundColor = '#fff';
  },
  components: {
    navCrumb,
    areaChart,
    gicSelectGroupMult
  }
};
</script>
<style type="text/scss" lang="scss" scoped>
.span-dot {
  display: inline-block;
  vertical-align: middle;
  width: 6px;
  height: 6px;
  margin-right: 6px;
  border-radius: 3px;
  &.bg-52c41a {
    background: #52c41a;
  }
  &.bg-f5222d {
    background: #f5222d;
  }
}
.bg-82C5FF {
  background: #82c5ff;
}
.color-508CEE {
  color: #508cee;
}
.color-FF585C {
  color: #ff585c;
}
.line-h-18 {
  line-height: 18px;
}
.tooltip-text {
  width: 100%;
  white-space: pre-wrap;
  word-break: break-all;
}
.w-293 {
  width: 293px;
}
.w-191 {
  width: 191px;
}
.el-alert--info {
  background: rgba(240, 245, 255, 1);
  border-radius: 2px;
  border: 1px solid rgba(133, 165, 255, 1);
  -webkit-box-align: flex-start;
  -webkit-align-items: flex-start;
  -ms-flex-align: flex-start;
  align-items: flex-start;
  .el-alert__icon {
    font-size: 12px;
    padding-top: 3px;
  }
}
.my-customer-wrap {
  height: 100%;
}
.right-content {
  /*width: 100%;*/
  padding: 0 20px 20px 20px;
  min-height: calc(100% - 160px);
  .right-box {
    background: #fff;
    min-height: 500px;
    padding: 0px;
    .apps-content {
      .apps-content-right {
        width: 100%;
        padding: 20px;
        background: #fff;
        .overstore-body {
          background: #fff;
        }
        .daily-set-wrap {
          height: 100%;
          background: #fff;
        }
        .app-detail-wrap {
          height: 100%;
          background: #fff;
        }
        .common-set-wrap {
          height: 100%;
          background: #fff;
        }
      }
    }
  }
}
.no-data-char {
  margin: 116px 0 140px 0;
}
</style>
